<template>
    <div>
        <breadcrumb-component title="Contas bancárias" :pages="breadPages"/>

        <panel-component title="Listar contas bancárias" :pages="breadPages" length="8">
            <div class="form-group col-md-6">
                <router-link class="btn btn-primary" :to="{name: 'banks.create'}">
                    <i class="fa fa-plus-circle"></i> Cadastrar conta
                </router-link>
            </div>
            <div class="table-responsive col-md-12">
                <table class="table table-striped table-hover table-bordered">
                    <thead>
                    <tr>
                        <th>Nome</th>
                        <th>Saldo</th>
                        <th>Cadastrado em</th>
                        <th class="text-center" style="width: 130px">Ação</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="bank in banks">
                        <td>{{bank.name}}</td>
                        <td>{{bank.saldo | currency('R$', 2, {decimalSeparator: ',', thousandsSeparator: '.'})}}</td>
                        <td>{{bank.created_at | dateFormat}}</td>
                        <td class="text-center">
                            <router-link
                                    :to="{name: 'banks.edit', params: {id: bank.id}}"
                                    class="btn btn-xs btn-info ">
                                <i class="fa fa-pencil"></i>
                            </router-link>
                            <button class="btn btn-xs btn-danger" @click.prevent="confirmDestroy(bank)">
                                <i class="fa fa-remove"></i>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </panel-component>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'banks', name: 'Financeiro', active: false},
                    {link: 'banks', name: 'Contas bancárias', active: false},
                    {link: 'banks', name: 'Listar', active: true},
                ]
            }
        },

        created() {
            this.loadBanks()
        },

        computed: {
            banks() {
                return this.$store.state.banks.items
            }
        },

        methods: {
            loadBanks() {
                this.$store.dispatch('loadBanks')
            },

            confirmDestroy(bank) {
                this.$snotify.confirm(`Deseja realmente apagar a conta bancária: ${bank.name} ?`, 'Deletar ?', {
                    timeout: 5000,
                    showProgressBar: true,
                    closeOnClick: false,
                    pauseOnHover: true,
                    buttons: [
                        {
                            text: 'Sim', action: (toast) => {
                            this.$snotify.remove(toast.id)
                            this.destroyUnity(bank.id)
                        }
                        },
                        {
                            text: 'Não', action: (toast) => {
                            this.$snotify.remove(toast.id)
                        }
                        },
                    ]
                })
            },

            destroyUnity(id) {
                this.$store.dispatch('destroyBank', id)
                    .then(() => {
                        this.loadBanks()
                        this.$snotify.success('Conta apagada com sucesso!', 'Sucesso')
                    })
                    .catch(() => {
                        this.$snotify.error('Não foi possível apagar a conta!', 'Error')
                    })
            }
        }
    }
</script>